﻿package 
{
	import com.brianhadaway.BasicTracker;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.geom.Point;

	/**
	 * @author bhadaway
	 */
	public class MotionHitTest extends BasicTracker 
	{
		
		private var _chaser:Sprite;
		private var _chaserBitmap:Bitmap;
		
		public function MotionHitTest() 
		{
			super();
			
			_chaser = new Sprite();
			_chaser.graphics.beginFill(0x0000FF);
			_chaser.graphics.drawCircle(25,25,25);
			_chaser.graphics.endFill();
			
			var chaserBitmapData:BitmapData = new BitmapData(50,50,true,0x000000);
			chaserBitmapData.draw(_chaser);
			_chaserBitmap = new Bitmap(chaserBitmapData);
			addChild(_chaserBitmap);
			
			_chaser.graphics.clear();
			_chaser = null;
			
			stage.addEventListener(MouseEvent.MOUSE_MOVE, onMove);
		}
		
		public override function init():void
		{
			//add configuration overrides here
			showVideo = false;
			super.init();	
		}
		
		private function onMove(e:MouseEvent) : void 
		{
			_chaserBitmap.x = mouseX - (_chaserBitmap.width *0.5);
			_chaserBitmap.y = mouseY - (_chaserBitmap.height *0.5);
			
			e.updateAfterEvent();
		}
		
		public override function render(e:TimerEvent = null):void
		{
			super.render();
			if(output.hitTest(new Point(0, 0), 0xFF, _chaserBitmap, new Point(_chaserBitmap.x, _chaserBitmap.y)))
			{
				_chaserBitmap.alpha = 0.5;
			}
			else
			{
				_chaserBitmap.alpha = 1;	
			}
		}
	}
}
